#include "hdf5.h"               /* HDF header files */
#include "mfhdf.h"

typedef struct data_type_info
{
    uint8 endian;           /* 1 is big endian and 0 little endian */
    hid_t num_type;         /* for numerical type of H5T_INTEGER and H5T_FLOAT, e.g. H5T_STD_I16BE and H5T_IEEE_F32BE, for non-numerical, it is -1 */
    H5T_class_t type_class; /* original H5T_class_t */
    size_t size;            /* number of bytes for each datum. Note that for H5T_C_S1, size is same as the length of the string. */
    H5T_sign_t sign;        /* sign or unsigned for integer data types */
}DATA_TYPE_INFO;

typedef long int           int64;
typedef unsigned long int  uint64;

char *get_attr_metadata(char *hdf_fname, char *meta_gname);
char *get_attr_metadata_byID(int H5IN, int32 sd_id, char *meta_gname);
void get_all_metadata(char *meta_str, char **meta_name, char **meta_val, int *meta_cnt);
void get_sel_metadata(char *meta_str, char *meta_name, char **meta_val, int *meta_cnt, int case_ch);
void copy_metadata(int H5IN, int32 in_sd_id, int H5OUT, int32 out_sd_id);
void update_gid_dt(char *loc_gid, char *prod_dt);
void write_modss_metadata(int32 in_sd_id, int32 out_sd_id, char **meta_names, char **meta_vals);
char *update_modss_metadata(char *attr_buf, int org_len, int imeta, char **meta_names, char **meta_vals);
/* void get_attr_npp_sel_metadata(char *hdf_fname, char *meta_gname, char *meta_val); */
void *get_attr_sel_metadata(const char* hdf_fname, char *attr_name, int32 *attr_type, int32 *attr_cnt);
void copy_H5_all_metedata_strings_to_H4(int32 H5_sd_id, int32 H4_sd_id);
int HDF5_read_one_dataset_STRING(hid_t h5_file_id, const char *h5_dataset_name, void** rdata, size_t *);
herr_t HDF5_attr_info(hid_t loc_id, const char *name, const H5A_info_t *ainfo, void *opdata);
void H5_print_all_attr_groups(int32 H5_sd_id, const char* key_str_control);
int HDF5_group_attrs(hid_t h5_file_id, const char *h5_group_name, const char* key_str_control);
herr_t H5_SDattrinfo(hid_t loc_id, const char *obj_name, int idx, char *attr_name, int *attr_H4_type, int *attr_cnt);
herr_t H5_SDreadattr(hid_t loc_id, const char *obj_name, int idx, int attr_cnt, void *attr_buf);
DATA_TYPE_INFO get_HDF5_data_type_info(hid_t tid, char *name);
unsigned char byte_order(void);
